Linux* Base Driver for the Intel(R) PRO/100 Family of Adapters
==============================================================

December 2, 2002


Contents
========

- In This Release
- Supported Adapters
- Building and Installation
- Command Line Parameters
- CPU Cycle Saver
- Additional Configurations
- Known Issues
- Support


In This Release
===============

This file describes the Linux* Base Driver for the Intel(R) PRO/100 Family of
Adapters, version 2.2.x. This driver is intended for 2.4.x kernels; it is 
known to build properly on 2.4.x kernels through 2.4.18. Intel focused testing
on Intel architectures running the 2.4.18 kernel. This driver includes support
for Itanium(TM)-based systems.

The Intel PRO/100 driver is only supported as a loadable module at this time.
Intel is not supplying patches against the kernel source to allow for static 
linking of the driver. For questions related to hardware requirements, refer 
to the documentation supplied with your Intel PRO/100 adapter.


Supported Adapters
==================

The following Intel network adapters are compatible with the drivers 
in this release:

Controller  Adapter Name                            Board IDs
----------  ------------                            ---------

82558       PRO/100+ PCI Adapter                    668081-xxx, 689661-xxx

82558       PRO/100+ Management Adapter             691334-xxx, 701738-xxx,
                                                    721383-xxx

82558       PRO/100+ Dual Port Server Adapter       714303-xxx, 711269-xxx, 
                                                    A28276-xxx

82558       PRO/100+ PCI Server Adapter             710550-xxx

82550       PRO/100 S Server Adapter                752438-xxx (82550)
82559                                               A56831-xxx, A10563-xxx,
                                                    A12171-xxx, A12321-xxx, 
                                                    A12320-xxx, A12170-xxx
                                                    748568-xxx (82559)
                                                    748565-xxx (82559)


82550       PRO/100 S Desktop Adapter               751767-xxx (82550)
82559                                               748592-xxx, A12167-xxx, 
                                                    A12318-xxx, A12317-xxx, 
                                                    A12165-xxx
                                                    748569-xxx (82559)



82559       PRO/100+ Server Adapter                 729757-xxx

82559       PRO/100 S Management Adapter            748566-xxx, 748564-xxx

82550       PRO/100 S Dual Port Server Adapter      A56831-xxx

82551       PRO/100 M Desktop Adapter               A80897-xxx

            PRO/100 S Advanced Management Adapter   747842-xxx, 745171-xxx

CNR         PRO/100 VE Desktop Adapter              A10386-xxx, A10725-xxx, 
                                                    A23801-xxx, A19716-xxx


            PRO/100 VM Desktop Adapter              A14323-xxx, A19725-xxx, 
                                                    A23801-xxx, A22220-xxx, 
                                                    A23796-xxx
   

To verify that your adapter is supported, find the board ID number on the 
adapter. Look for a label that has a barcode and a number in the format 
A12345-001. Match this to the list of numbers above.

For more information on how to identify your adapter, go to the Adapter & 
Driver ID Guide at:

  http://support.intel.com/support/network/adapter/pro100/21397.htm

For the latest Intel network drivers for Linux, refer to the following 
website. In the search field, enter your adapter name or type, or use the 
networking link on the left to search for your adapter:

  http://downloadfinder.intel.com/scripts-df/support_intel.asp


Building and Installation
=========================

To build a binary RPM* package of this driver run 'rpmbuild -tb 
<filename.tar.gz>'. Replace <filename.tar.gz> with the specific file name of 
the driver. 

NOTES: For the build to work properly it is important that the currently
       running kernel MATCH the version and configuration of the installed
       kernel source. If you have just recompiled your kernel, reboot the 
       system and choose the correct kernel to boot.

1. Move the base driver tar file to the directory of your choice. For 
   example, use: /home/username/e100 or /usr/local/src/e100.

2. Untar/unzip the archive by entering the following, where <x.x.x> is the 
   version number for the driver tar:

     tar xfz e100-<x.x.x>.tar.gz

3. Change to the driver src directory by entering the following, where 
   <x.x.x> is the version number for the driver tar:

     cd e100-<x.x.x>/src/	

4. Compile the driver module:

     make install

   The binary will be installed as one of the following: 
 
     /lib/modules/<kernel_version>/kernel/drivers/net/e100.o

     /lib/modules/<kernel_version>/net/e100.o

   The install locations listed above are the default locations. They may 
   not be correct for certain Linux distributions. For more information, see
   the ldistrib.txt file included in the driver tar.

5. Install the module:

     insmod e100 <parameter>=<value>
 
6. Assign an IP address to the interface by entering the following, where 
   <x> is the interface number:

     ifconfig eth<x> <IP_address>

7. Verify that the interface works. Enter the following, where <IP_address>
   is the IP address for another machine on the same subnet as the interface
   that is being tested:

     ping <IP_address>	
	

Command Line Parameters
=======================

If the driver is built as a module, the  following optional parameters are 
used by entering them on the command line with the modprobe or insmod command
using this syntax:

     modprobe e100 [<option>=<VAL1>,<VAL2>,...]

     insmod e100 [<option>=<VAL1>,<VAL2>,...] 

For example, with two Intel PRO/100 PCI adapters, entering:
	
     modprobe e100 TxDescriptors=32,128

loads the e100 driver with 32 TX resources for the first adapter and 128 TX 
resources for the second adapter. This configuration favors the second 
adapter. The driver supports up to 16 network adapters concurrently.

The default value for each parameter is generally the recommended setting,
unless otherwise noted.

NOTE: Giving any command line option the value "-1" causes the driver to use 
      the appropriate default value for that option, as if no value was 
      specified.


BundleMax
Valid Range: 1-65535
Default Value: 6
   This parameter holds the maximum number of small packets (less than 128
   bytes) in a bundle. Suggested values range from 2 to 10. See "CPU Cycle 
   Saver."

BundleSmallFr
Valid Range: 0-1 (0=off, 1=on)
Default Value: 0
   The value 1 (on) causes small packets (less than 128 bytes) to be bundled. 
   See "CPU Cycle Saver."

e100_speed_duplex
Valid Range: 0-4 (1=10half;2=10full;3=100half;4=100full)
Default Value: 0
   The default value of 0 sets the adapter to auto-negotiate. Other values
   set the adapter to forced speed and duplex. 
   Example usage: insmod e100.o e100_speed_duplex=4,4 (for two adapters)

flow_control
Valid Range: 0-1 (0=off, 1=on)
Default Value: 0
   This parameter controls the automatic generation(Tx) and response(Rx) to 
   Ethernet PAUSE frames. flow_control should NOT be set to 1 when the 
   adapter is connected to an interface that does not support Ethernet PAUSE 
   frames and when the e100_speed_duplex parameter is NOT set to zero. 

IntDelay
Valid Range: 0-65535 (0=off)
Default Value: 1536
   This parameter holds the number of time units (in adapter terminology)
   until the adapter generates an interrupt. The recommended value for 
   IntDelay is 1536 (upon initialization). Suggested values range from 
   512 to 2048. See "CPU Cycle Saver."

IFS
Valid Range: 0-1 (0=off, 1=on)
Default Value: 1
  Inter Frame Spacing (IFS) aims to reduce the number of Ethernet frame
  collisions by altering the time between frame transmissions. When IFS is 
  enabled the driver tries to find an optimal IFS value. It is used only at 
  half duplex.

RxDescriptors
Valid Range: 8-1024
Default Value: 64
   This parameter defines the number of receive descriptors allocated by 
   the driver. Increasing this value allows the driver to buffer more 
   incoming packets before the driver is required to service an interrupt. 
   The maximum value for Itanium-based systems is 64.

TxDescriptors
Valid Range: 19-1024
Default Value: 64
   This value is the number of transmit descriptors allocated by the driver. 
   Increasing this value allows the protocol stack to queue more transmits at
   the driver level. The maximum value for Itanium-based systems is 64.

ucode
Valid Range: 0-1 (0=off, 1=on)
Default Value: 0 for 82558-based adapters
               1 for 82559, 82550, and 82551-based adapters
   On uploads the micro code to the adapter, which enables CPU Cycle Saver. 
   See the section "CPU Cycle Saver" below.
   Example usage: insmod e100.o ucode=1

   Not available on 82557-based adapters.

XsumRX
Valid Range: 0-1 (0=off, 1=on)
Default Value: 1
   On allows Rx checksum offloading for TCP/UDP packets. Requires that the 
   hardware support this feature.

   Not available on 82557 and 82558-based adapters.


CPU Cycle Saver
================

CPU Cycle Saver reduces CPU utilization by reducing the number of interrupts 
that the adapter generates.

When CPU Cycle Saver is turned off, the adapter generates one interrupt for 
every frame that is received. This means that the operating system stops what
it is doing and switches to the network driver in order to process the 
receive.

When CPU Cycle Saver is on, the adapter does not generate an interrupt for 
every frame it receives. Instead, it waits until it receives several frames 
before generating an interrupt. This reduces the amount of time spent 
switching to and from the driver. 

CPU Cycle Saver consists of these arguments: IntDelay, BundleMax and 
BundleSmallFr. When IntDelay is increased, the adapter waits longer for 
frames to arrive before generating the interrupt. By increasing BundleMax, 
the network adapter waits for the number of small frames (less than 128 bytes)
specified to arrive before generating the interrupt. When BundleSmallFr is 
disabled, the adapter does not bundle small packets. Such small packets are 
often, but not always, control packets that are better served immediately;
therefore, BundleSmallFr is disabled by default.

For most users, it is recommended that CPU Cycle Saver be used with the 
default values specified in the Command Line Parameters section. However, in 
some cases, performance problems may occur with CPU Cycle Saver. If such 
problems are observed, we recommend turning off this feature by setting 
ucode=0.


Additional Configurations
=========================

  Configuring the Driver on Different Distributions
  -------------------------------------------------

  Configuring a network driver to load properly when the system is started is 
  distribution dependent. Typically, the configuration process involves adding 
  an alias line to /etc/modules.conf as well as editing other system startup 
  scripts and/or configuration files.  Many popular Linux distributions ship 
  with tools to make these changes for you. To learn the proper way to 
  configure a network device for your system, refer to your distribution 
  documentation. If during this process you are asked for the driver or module 
  name, the name for the Linux Base Driver for the Intel PRO/100 Family of 
  Adapters is e100.

  As an example, if you install the e100 driver for two PRO/100 adapters 
  (eth0 and eth1) and set the speed and duplex to 10full and 100half, add the 
  following to modules.conf:

       alias eth0 e100
       alias eth1 e100
       options e100 e100_speed_duplex=2,3

  Viewing Link Messages
  ---------------------
  In order to see link messages and other Intel driver information on your 
  console, you must set the dmesg level up to six. This can be done by 
  entering the following on the command line before loading the e100 driver: 

       dmesg -n 6

  If you wish to see all messages issued by the driver, including debug 
  messages, set the dmesg level to eight.

  NOTE: This setting is not saved across reboots.

  Enabling Wake on LAN* (WoL)
  ---------------------------
  WoL is provided through the Ethtool* utility. Ethtool is included with Red 
  Hat* 8.0. For other Linux distributions, download and install Ethtool from 
  the following website: http://sourceforge.net/projects/gkernel. 

  For instructions on enabling WoL with Ethtool, refer to the website listed
  above.

  WoL will be enabled on the system during the next shut down or reboot. For
  this driver version, in order to enable WoL, the e100 driver must be 
  loaded when shutting down or rebooting the system.


Known Issues
============

NOTE: For distribution-specific information, refer to the ldistrib.txt file 
      included in the driver tar.


  Driver Compilation
  ------------------

  When trying to compile the driver by running make install, the following
  error may occur: 

      "Linux kernel source not configured - missing version.h"

  To solve this issue, create the version.h file by going to the Linux source 
  tree and entering:

      make include/linux/version.h.


  Multiple Interfaces on Same Ethernet Broadcast Network
  ------------------------------------------------------

  Due to the ARP behavior on Linux, it is not possible to have one system on 
  two IP networks in the same Ethernet broadcast domain (non-partitioned 
  switch) behave as expected. All Ethernet interfaces will respond to IP 
  traffic for any IP address assigned to the system. This results in 
  unbalanced receive traffic.

  When this occurs, transmits and receives for a single conversation can be 
  split across different network interfaces. Additionally, the server might 
  have up to twice as much transmit capacity as receive capacity, which can 
  result in the receive side being overrun and dropping receives.

  If you have multiple interfaces in a server, install them in different 
  switches or partition the switch into VLANs to prevent broadcast traffic 
  from going to the wrong interface.  This does not apply when using a teaming
  solution, like ANS.


Support
=======

For general information, go to the Intel support website at:

    http://support.intel.com

If an issue is identified with the released source code on the supported
kernel with a supported adapter, email the specific information related to 
the issue to linux.nics@intel.com.


License
=======

This software program is released under the terms of a license agreement 
between you ('Licensee') and Intel. Do not use or load this software or any 
associated materials (collectively, the 'Software') until you have carefully 
read the full terms and conditions of the LICENSE located in this software 
package. By loading or using the Software, you agree to the terms of this 
Agreement. If you do not agree with the terms of this Agreement, do not 
install or use the Software.

* Other names and brands may be claimed as the property of others.